#!/usr/bin/env python2
from __future__ import print_function
import time
import sys
import os

# while true; do cat stat | sed 's/ /\n/g' > /dev/shm/b; diff /dev/shm/a /dev/shm/b; cat /dev/shm/b > /dev/shm/a; sleep 1; done
# while true; do cat stat | cut -d' ' -f14,15 | while read a b; do echo "$a + $b = $(( a + b ))"; done; sleep 0.5; done
# ls -1 | grep -E '^[0-9]{1,9}' | sort -n | while read x; do echo -ne "$x   "; cat $x/stat | cut -d' ' -f22; done
# sleep 900 & sleep 0.5; pid=$(ps aux | grep 'sleep[ ]900' | sed 's/[^ ]*  *//;s/ .*//'); cat /proc/$pid/stat | cut -d' ' -f22; kill $pid



# config 
thr_top = 5
thr_time = 10000
debug = True
debug = False

# everybody loves globals
origo = int(time.time())
watching = []

# monitored process
class Inf:
	def __init__(self, total, tuser, tkern, memsz, origo, pid, name):
		self.total = total
		self.tuser = tuser
		self.tkern = tkern
		self.memsz = memsz
		self.origo = origo
		self.pid = pid
		self.name = name
		self.x_fn = None
		self.x_exe = None

# get current list of processes, returns Inf's
def getprocs():
	pids = os.listdir('/proc')
	ret = []
	for spid in pids:
		try:
			pid = int(spid)
			#print("%d: " % (v,), end='')
		except:
			continue

		try:
			with open('/proc/%d/stat' % (pid,), 'r') as f:
				stat = f.read()
		except:
			# died between listdir and here
			continue

		ofs1 = stat.index('(')
		ofs2 = stat.index(')')
		name = stat[ofs1+1:ofs2]
		name = name.split('/')[0]
		stat = stat[ofs2+2:].split(' ')
		tuser = int(stat[11])
		tkern = int(stat[12])
		origo = int(stat[19])
		memsz = int(stat[20])
		total = tuser + tkern
		ret.append(Inf(
			total, tuser, tkern, memsz, origo, pid, name))
	return ret

if __name__ == '__main__':
	while True:
		ts = int(time.time())

		with open('/proc/loadavg', 'r') as f:
			avg = f.read()
		avg = avg.split(' ')[0]
		with open('loadavg', 'a') as f:
			f.write('%d %s\n' % (ts,avg,))

		procs = sorted(getprocs(), key=lambda x: x.total, reverse=True)
		unwatch = []

		# log cpu usage of all processes that we are monitoring
		for po in watching:
			now = None
			for pn in procs:
				if po.pid == pn.pid and po.origo == pn.origo:
					now = pn
					break
			if now is None:
				unwatch.append(po)
				print('xxx removing %s' % (po.name,))
				continue

			# filename; sessionOrigo-procName-procOrigo-procPid 
			if po.x_fn is None:
				po.x_fn = '%d-%s-%d-%d' % (origo,now.name,now.origo,now.pid,)

			if po.x_exe is None:
				with open('/proc/%d/cmdline' % (po.pid,), 'r') as f:
					po.x_exe = f.read().replace('\0', ' ')
				with open(po.x_fn, 'a') as f:
					f.write('+ %s\n' % (po.x_exe,))
				if debug:
					print('%s' % (po.x_exe,))

			tx = '%d %d %d %d %d\n' % (ts,
				now.total,
				now.tuser,
				now.tkern,
				#now.total - po.total,
				#now.tuser - po.tuser,
				#now.tkern - po.tkern,
				now.memsz)

			with open(po.x_fn, 'a') as f:
				f.write(tx)

			if debug:
		 		print('%s => %s' % (po.x_fn,tx,), end='')
			po.total = now.total
			po.tuser = now.tuser
			po.tkern = now.tkern
			po.memsz = now.memsz

		for po in unwatch:
			watching.remove(po)

		# see if we need to monitor any additional processes
		# ('thr_top' consumers that are over 'thr_time' consumption)
		left = thr_top
		for proc in procs:
			if proc.total < thr_time:
				break
			left -= 1
			if left < 0:
				break
			found = None
			for old in watching:
				if old.pid == proc.pid and old.origo == proc.origo:
					found = old
					break
			if found is None:
				watching.append(proc)

		if debug:
			print('ayy')
		time.sleep(60)

